unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.Buttons, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Shape1: TShape;
    Timer1: TTimer;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Panel5: TPanel;
    SpeedButton3: TSpeedButton;
    Label5: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private declarations }
    x,y   : integer;
    dx,dy : integer;

    pa,pb : integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  x := Shape1.Left + Shape1.Width  div 2;
  y := Shape1.Top  + Shape1.Height div 2;

  dx := 5;
  dy := 8;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
  Label5.Caption := Key;

  if UpCase(Key) = 'O' then begin
    Panel5.Top := Panel5.Top - 5;

    if (Panel5.top < Panel3.Top + Panel3.Height)
      then begin
        Panel5.Top := Panel5.Top + 5;
        beep;
      end;
  end;

  if Upcase(Key) = 'L' then begin
      Panel5.Top := Panel5.Top + 5;

    if (Panel5.top + Panel5.Height > Panel4.Top)
      then begin
        Panel5.Top := Panel5.Top - 5;
        beep;
      end;
  end;

end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  Timer1.Enabled := true;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  Timer1.Enabled := false;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  pa := 0;
  pb := 0;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  pcbola, pcRaque, tmRaque : integer;

begin
  x := x + dx;
  y := y + dy;

  with Shape1 do begin
    // mov. izquierda-derecha
    Left := x - Width  div 2;
    if (Left + Width) > Panel2.Left+20 then begin
      pcbola  := Shape1.Top + Shape1.Height div 2;
      pcRaque := Panel5.Top + Panel5.Height div 2;
      tmRaque := Panel5.Height div 2 - 5;

      if      (pcbola >= pcRaque - tmRaque)
          and (pcbola <= pcRaque + tmRaque)
      then begin
        dx := -dx ;
        x  := x + dx;
      end
      else begin
        inc(pa);
        Label2.Caption := IntToStr(pa);
        x  := Panel1.Left + Panel1.Width + 22;
        y  := Panel1.Top + Panel1.Height div 2;
        Timer1.Enabled := false;
      end;

    end;
    if Left  <  Panel1.Left + Panel1.Width then begin
      dx := -dx;
      x  := x + dx;
    end;

    // mov. arriba-abajo
    Top := y - Height  div 2;
    if Top  < Panel3.Top + Panel3.Height then begin
      dy := -dy;
      y  := y + dy;
    end;
    if Top + Height >  Panel4.Top  then begin
      dy := -dy;
      y  := y + dy;
    end;

  end;

end;


end.
